module AVL (
    balance,
    insert,
    supp
)
where

import HBinTree

rg t | isEmpty t = t
     | otherwise = consNode (root ad) (consNode (root t) ag (left ad)) (right ad)
     where ag = left t
           ad = right t

rd t | isEmpty t = t
     | otherwise = consNode (root ag) ag (consNode (root t) (right ag) ad)
     where ag = left t
           ad = right t

balance t | abs (height ag - height ad) > 1 = 
    if height ag - height ad == 2
        then if height agg > height agd
            then rd t
            else rd (consNode (root t) (rg ag) ad)
        else if height add > height adg
            then rg t
            else rg (consNode (root t) ag (rd ad))
          | otherwise = t
    where ag = left t
          ad = right t 
          agg = left ag
          agd = right ag
          add = right ad
          adg = left ad

insert x t | isEmpty t = consNode x consEmpty consEmpty
           | x < (root t) = balance (consNode (root t) (insert x (left t)) (right t))
           | otherwise = balance (consNode (root t) (left t) (insert x (right t)))

cutMax t | isEmpty (right t) = (root t, left t)
         | otherwise = (m, consNode (root t) (left t) suppt)
              where (m, suppt) = cutMax (right t)

supp x t | x < root t = balance (consNode (root t) (supp x (left t)) (right t))
         | root t < x = balance (consNode (root t) (left t) (supp x (right t)))
         | isEmpty (left t) = balance (right t)
         | otherwise = balance (consNode m cutm (right t))
               where (m, cutm) = cutMax (left t)
