module HBinTree (
    Tree(Node, Empty),
    consEmpty,
    consNode,
    root,
    left,
    right,
    isEmpty,
    height,
    isLeaf,
    prefixe
)
where

{- Definition of binary tree -}
data Tree a = Empty | Node a (Tree a) (Tree a) Int deriving (Show)

consEmpty :: Tree a
consEmpty = Empty

consNode :: a -> Tree a -> Tree a -> Tree a
consNode e lt rt = Node e lt rt (1 + max (height lt) (height rt))

root :: Tree a -> a
root (Node elem _ _ _) = elem
root Empty = error "Tree is vide, banane"

left :: Tree a -> Tree a
left (Node _ ag _ _) = ag
left Empty = error "Tree is vide, banane"

right :: Tree a -> Tree a
right (Node _ _ ad _) = ad
right Empty = error "Tree is vide, banane"

isEmpty :: Tree a -> Bool
isEmpty Empty = True
isEmpty _ = False

isLeaf :: Tree a -> Bool
isLeaf a = not (isEmpty a) && (isEmpty (left a)) && (isEmpty (right a))

height Empty = 0
height (Node _ _ _ h) = h

prefixe :: (Show a) => Tree a -> String
prefixe Empty = "[]"
prefixe (Node elem ag ad _) = "[" ++ (show elem) ++ ", " ++ (prefixe ag) ++ ", " ++ (prefixe ad) ++ "]"

