import HBinTree
import AVL

{- 
 
 Correction Fiche TP08

 Author  : Sebastien Verel
 Date    : 2017/12/22
 Licence : CC-BY-SA

-}

{- Exo 1 -}

comptage :: Int -> Int -> Tree Int -> Int
comptage a b t | isEmpty t = 0
               | b < root t = comptage a b (left t)
               | root t < a = comptage a b (right t)
               | otherwise = comptage a b (left t) + 1 + comptage a b (right t) 


{- Exo 2 -}

insertPoint (x, y) t vertical | isEmpty t = consNode (x, y) consEmpty consEmpty
                              | vertical && x <= fst (root t) = consNode (root t) (balance (insertPoint (x,y) (left t) False)) (right t) 
                              | vertical = consNode (root t) (left t) (balance (insertPoint (x,y) (right t) False)) 
                              | y <= snd (root t) = consNode (root t) (balance (insertPoint (x,y) (left t) True)) (right t) 
                              | otherwise = consNode (root t) (left t) (balance (insertPoint (x,y) (right t) True)) 

nbPoints (x1, y1) (x2, y2) t =
    nbPoints' t True
    where nbPoints' t vertical | isEmpty t = 0
                               | x1 <= xr && xr <= x2 && y1 <= yr && yr <= y2 = 
                                    1 + nbPoints' (left t) (not vertical) + nbPoints' (right t) (not vertical)
                               | otherwise = if ((vertical && x2 < xr) || (not vertical && yr < y1))
                                                then nbPoints' (left t) (not vertical)
                                                else if ((vertical && xr < x1) || (not vertical && y2 < yr))
                                                    then nbPoints' (right t) (not vertical)
                                                    else nbPoints' (left t) (not vertical) + nbPoints' (right t) (not vertical)
                                    where (xr, yr) = root t

main = let t = (foldl (\ t x -> insert x t) consEmpty [12, 23, 11, 78, 34, 56])
           points = foldl (\ t p -> insertPoint p t True) consEmpty [(120, 180), (320, 160), (110, 150), (40, 100)]
           in do
                print $ comptage 57 143 t
                print $ comptage 12 43 t
                print $ prefixe points
                print $ nbPoints (100, 100) (250, 250) points
